/****************************************************************************/
/* presentations/examples/example07a-garbage-collection.p   */ 
/* Copyright 2011 TDK Consulting Services Inc.              */
/* Timothy D. Kuehn - tim.kuehn@gmail.com                   */

USING presentation.classes.*.

DEFINE VARIABLE oClass AS DestructorClass NO-UNDO.
 
oClass = NEW DestructorClass().

MESSAGE "run child" VIEW-AS ALERT-BOX.

RUN presentation/examples/example07b-garbage-collection.p.

MESSAGE "pause after run" VIEW-AS ALERT-BOX.

DELETE OBJECT oClass.

MESSAGE "pause after delete" VIEW-AS ALERT-BOX.

/****************************************************************************/
/* presentations/examples/example07b-garbage-collection.p   */ 

USING presentation.classes.*.

DEFINE VARIABLE oClass AS DestructorClass NO-UNDO.
 
oClass = NEW DestructorClass("child procedure").

MESSAGE "leave child"
    VIEW-AS ALERT-BOX.
    
/****************************************************************************/
/* presentation/classes/DestructorClass.cls */

CLASS presentation.classes.DestructorClass: 
DEFINE VARIABLE cur-name AS CHARACTER.

DESTRUCTOR DestructorClass(): 
MESSAGE "delete " cur-name
    VIEW-AS ALERT-BOX.
END DESTRUCTOR.

CONSTRUCTOR DestructorClass():
ASSIGN cur-name = "default constructor".
END CONSTRUCTOR.

CONSTRUCTOR DestructorClass(cur-parm AS CHARACTER):
ASSIGN cur-name = cur-parm.
END CONSTRUCTOR.
END CLASS.