/****************************************************************************/
/* presentation/examples/example08-access.p     */
/* Copyright 2011 TDK Consulting Services Inc.  */
/* Timothy D. Kuehn tim.kuehn@gmail.com         */

USING presentation.classes.*.

DEFINE VARIABLE oClassA AS AccessClass NO-UNDO.
DEFINE VARIABLE oClassB AS AccessClass NO-UNDO.

oClassA = NEW AccessClass().
oClassB = NEW AccessClass("parm").

MESSAGE "A:" oClassA:Getchar()   SKIP 
        "B:" oClassB:GetChar()
    VIEW-AS ALERT-BOX.
            
/****************************************************************************/
/* presentation/classes/AccessClass.cls  */

CLASS presentation.classes.AccessClass: 

DEFINE PRIVATE VARIABLE cur-char AS CHARACTER    NO-UNDO.
DEFINE PRIVATE VARIABLE cur-int  AS INTEGER      NO-UNDO.

METHOD PUBLIC CHARACTER GetChar():
RETURN(cur-char).
END METHOD.

/****************************************************************************/
CONSTRUCTOR PUBLIC AccessClass():
THIS-OBJECT("parm1", 1).
END CONSTRUCTOR.

/****************************************************************************/
CONSTRUCTOR PUBLIC AccessClass(parm AS CHARACTER):
THIS-OBJECT(parm, 1).
END CONSTRUCTOR.

/****************************************************************************/
CONSTRUCTOR PRIVATE AccessClass(parm1 AS CHARACTER, 
                                parm2 AS INTEGER).
ASSIGN  
    cur-char    = parm1
    cur-int     = parm2
    .

END CONSTRUCTOR.

END CLASS.
            