/****************************************************************************/
/* presentation/examples/example04-signatures.p */
/* Copyright 2011 TDK Consulting Services Inc.  */
/* Timothy D. Kuehn - tim.kuehn@gmail.com       */

USING presentation.classes.*.

DEFINE VARIABLE oClass1 AS SignatureMatch NO-UNDO. 
DEFINE VARIABLE oClass2 AS SignatureMatch NO-UNDO. 

oClass1 = NEW SignatureMatch().
oClass2 = NEW SignatureMatch().

oClass1:SetVariable("a string").
oClass2:SetVariable(123, 456).

MESSAGE oClass1:GetVariable()   SKIP 
        oClass2:GetVariable()
    VIEW-AS ALERT-BOX.        

/****************************************************************************/
/* presentation/classes/SignatureMatch.cls */

CLASS presentation.classes.SignatureMatch: 

DEFINE VARIABLE ExampleVar AS CHARACTER NO-UNDO.

METHOD PUBLIC VOID SetVariable(prefixvalue AS INTEGER, 
                               suffixvalue AS INTEGER 
                               ):
SetVariable(STRING(prefixvalue, '999') + "." + 
            STRING(suffixvalue, '999')).
END METHOD.

METHOD PUBLIC VOID SetVariable(newvalue AS CHARACTER):
ExampleVar = newvalue.
END METHOD.

METHOD PUBLIC CHARACTER GetVariable():
RETURN(ExampleVar).
END METHOD.

END CLASS.
