/****************************************************************************/
/* presentation/examples/example05-constructor.p    */
/* Copyright 2011 TDK Consulting Services Inc.      */
/* Timothy D. Kuehn - tim.kuehn@gmail.com           */

USING presentation.classes.*.

DEFINE VARIABLE aClass AS ConstructorClass NO-UNDO.
DEFINE VARIABLE bClass AS ConstructorClass NO-UNDO.

aClass = NEW ConstructorClass().
bClass = NEW ConstructorClass("my values").

MESSAGE aclass:GetVariable()    SKIP 
        bclass:GetVariable()
VIEW-AS ALERT-BOX.          

/****************************************************************************/
 /* presentation/classes/ConstructorClass.cls */

CLASS presentation.classes.ConstructorClass: 

DEFINE VARIABLE cur-value AS CHARACTER.

METHOD PUBLIC CHARACTER GetVariable():
RETURN(cur-value).
END METHOD.

CONSTRUCTOR PUBLIC ConstructorClass():
ASSIGN cur-value = "the time is now".
END CONSTRUCTOR.

CONSTRUCTOR PUBLIC ConstructorClass(new-value AS CHARACTER):
ASSIGN cur-value = new-value.
END CONSTRUCTOR.


END CLASS.