/****************************************************************************/
/* presentation/examples/example09b-static.p    */
/* Copyright 2011 TDK Consulting Services Inc.  */
/* Timothy D. Kuehn tim.kuehn@gmail.com         */

USING presentation.classes.*.

DEFINE VARIABLE oStat AS StaticMembers NO-UNDO.

MESSAGE "SetDynProp" VIEW-AS ALERT-BOX.
oStat = NEW StaticMembers().

MESSAGE "SetStatProp" VIEW-AS ALERT-BOX.
StaticMembers:stat-value = "value".

/****************************************************************************/
/* presentation/classes/StaticMembers.cls */

CLASS presentation.classes.StaticMembers: 

DEFINE PUBLIC STATIC PROPERTY stat-value AS CHARACTER NO-UNDO GET. SET. 
DEFINE PUBLIC PROPERTY cls-value AS CHARACTER NO-UNDO GET. PRIVATE SET.

METHOD PUBLIC STATIC CHARACTER GetStatValue():
RETURN(stat-value).
END METHOD.

METHOD PUBLIC CHARACTER GetClsValue():
RETURN(cls-value).
END METHOD.

CONSTRUCTOR STATIC StaticMembers():
MESSAGE "Static Const" VIEW-AS ALERT-BOX.
END CONSTRUCTOR.

CONSTRUCTOR PUBLIC StaticMembers():
MESSAGE "Object Const" VIEW-AS ALERT-BOX.
ASSIGN cls-value = "cls".
END CONSTRUCTOR.

END CLASS.